from scipy import *

class dbase:
	"""
	A simple data-frame
	"""

	def __init__(self,fname):
		self.data = io.read_array(file(fname + '.txt','rb'))
		self.varnm = self.vardic(file(fname + '_labels.txt','rb'))

	def vardic(self,f):
		"""
		Making a dictionary with variable names and indices
		"""
		dic = {}; j = 0
		for i in f:
			dic[i[:-1]] = j
			j += 1
	
		return dic

	def get(self,*var):
		"""
		Selecting a column based on variable labels
		"""
		a = self.data[:,self.varnm[var[0]]]				# getting the data for the 1st element in self.data

		for i in var[1:]:						
			a = c_[a,self.data[:,self.varnm[i]]]		# concatenate column-wise, along last axis
	
		return a

# creating simulated data and variable labels
data = arange(15).reshape(5,3)		# the data array
io.write_array(file('data.txt','w'),data)

varnm = "a\nb\nc\n"							# variable labels
f = open('data_labels.txt','w')
f.write(varnm)
f.close()

# getting data by variable name
a = dbase("data")

print "Data from dbase class\n", a.data
print "\nVariable names from dbase class\n", a.varnm
print "\nTwo columns from dbase class, selected using variable names\n", a.get('a','c')
